Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs	(revision 11730)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs	(revision 11730)
@@ -0,0 +1,150 @@
+﻿using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Problems.GrammaticalOptimization {
+  // represents a sequence of symbols (non-terminal and terminal symbols)
+  // a sequence consisting only of terminal symbols can be a sentence of a language
+  // the class supports in-place manipulation of the sequence symbols (replace NT with another sequence)
+  // sequences provide efficient support left-canonical derivation by storing the index of the first non-terminal symbol
+  // maximal length of sequences is limited to 1000 symbols
+
+  // for symbols the same assumptions for the implementation of grammars apply
+  // - non-terminal symbols must be characters in the range [A..Z]
+  // - terminal symbols can be almost all other characters
+  public class Sequence : IEnumerable<char> {
+    private const int maxIdx = 200;
+
+    private int len;
+    private int idxOfFirstNt;
+    private readonly char[] symbols;
+
+    public char this[int idx] {
+      get { return symbols[idx]; }
+      set { throw new NotSupportedException(); }
+    }
+
+    public int Length {
+      get { return len; }
+      private set { len = value; }
+    }
+
+    public bool IsTerminal {
+      get { return idxOfFirstNt == -1; }
+    }
+
+    public int FirstNonTerminalIndex {
+      get { return idxOfFirstNt; }
+    }
+
+    public char FirstNonTerminal {
+      get { return symbols[idxOfFirstNt]; }
+    }
+
+    private Sequence() {
+      this.symbols = new char[maxIdx + 1];
+    }
+
+    // create a sequence from a character
+    public Sequence(char ch)
+      : this() {
+      this.len = 1;
+      symbols[0] = ch;
+
+      if (ch >= 'A' && ch <= 'Z') idxOfFirstNt = 0;
+      else idxOfFirstNt = -1;
+    }
+
+    // create a sequence from a string
+    public Sequence(string s)
+      : this() {
+      if (string.IsNullOrEmpty(s)) throw new ArgumentException();
+      if (s.Length > (maxIdx + 1)) throw new ArgumentException();
+      this.len = s.Length;
+      this.idxOfFirstNt = -1;
+
+      for (int i = 0; i < len; i++) {
+        symbols[i] = s[i];
+        if (idxOfFirstNt == -1 && symbols[i] >= 'A' && symbols[i] <= 'Z') {
+          idxOfFirstNt = i;
+        }
+      }
+    }
+
+    // cloning ctor
+    public Sequence(Sequence original)
+      : this() {
+      this.len = original.len;
+      Array.Copy(original.symbols, this.symbols, len);
+      this.idxOfFirstNt = original.idxOfFirstNt;
+    }
+
+    public void ReplaceAt(int position, int len, Sequence replacement) {
+      if (replacement == null) throw new ArgumentNullException();
+      if (len <= 0) throw new ArgumentException();
+      if (position + len >= maxIdx) throw new ArgumentException();
+      if (Length - len + replacement.Length > (maxIdx + 1)) throw new ArgumentException();
+      var lenDelta = replacement.Length - len;
+      var remainingPartLen = Length - position - len;
+      var startIdxOfRemainingPart = position + len + lenDelta;
+      Array.Copy(symbols, position + len, symbols, startIdxOfRemainingPart, remainingPartLen);
+      Array.Copy(replacement.symbols, 0, symbols, position, replacement.Length);
+
+      this.len = Length + lenDelta;
+      // when the first part contains an NT then it's not necessary to update the index
+      if (idxOfFirstNt >= 0 && idxOfFirstNt < position) return;
+      // if the replacement contains an NT then we can directly calculate the idx of that NT in the new sequence
+      if (replacement.idxOfFirstNt >= 0) {
+        this.idxOfFirstNt = position + replacement.idxOfFirstNt;
+      } else {
+        // otherwise we must find the first NT in the remaining part
+        idxOfFirstNt = -1;
+        for (int i = startIdxOfRemainingPart; idxOfFirstNt == -1 && i < Length; i++) {
+          if (symbols[i] >= 'A' && symbols[i] <= 'Z') idxOfFirstNt = i;
+        }
+      }
+    }
+
+    public IEnumerator<char> GetEnumerator() {
+      return symbols.AsEnumerable().Take(len).GetEnumerator();
+    }
+
+    public override string ToString() {
+      var sb = new StringBuilder(len);
+      sb.Append(symbols, 0, len);
+      return sb.ToString();
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return GetEnumerator();
+    }
+
+    public Sequence Subsequence(int startIdx, int len) {
+      if (startIdx < 0 || len <= 0) throw new ArgumentException();
+      if (startIdx >= this.len) throw new ArgumentException();
+      if (startIdx + len > this.len) throw new ArgumentException();
+      var subsequence = new Sequence {len = len};
+
+      Array.Copy(this.symbols, startIdx, subsequence.symbols, 0, len);
+      if (idxOfFirstNt < 0) {
+        subsequence.idxOfFirstNt = -1;
+      } else if (idxOfFirstNt < startIdx) {
+        // need to find first nt in subsequence
+        subsequence.idxOfFirstNt = -1;
+        for (int i = 0; subsequence.idxOfFirstNt == -1 && i < len; i++) {
+          if (subsequence.symbols[i] >= 'A' && subsequence.symbols[i] <= 'Z') subsequence.idxOfFirstNt = i;
+        }
+      } else if (idxOfFirstNt >= startIdx && idxOfFirstNt < startIdx + len) {
+        subsequence.idxOfFirstNt = idxOfFirstNt;
+      } else {
+        Debug.Assert(idxOfFirstNt >= startIdx + len);
+        subsequence.idxOfFirstNt = -1;
+      }
+      return subsequence;
+    }
+  }
+}
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SymbolicRegressionPoly10Problem.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SymbolicRegressionPoly10Problem.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SymbolicRegressionPoly10Problem.cs	(revision 11730)
@@ -16,5 +16,5 @@
     private const string grammarString = @"
     G(E):
-    E -> a | b | c | d | e | f | g | h | j | a+E | b+E | c+E | d+E | e+E | f+E | g+E | h+E | j+E | a*E | b*E | c*E | d*E | e*E | f*E | g*E | h*E | j*E 
+    E -> a | b | c | d | e | f | g | h | i | j | a+E | b+E | c+E | d+E | e+E | f+E | g+E | h+E | i+E | j+E | a*E | b*E | c*E | d*E | e*E | f*E | g*E | h*E | i*E | j*E
     ";
 
@@ -47,4 +47,5 @@
         }
         // poly-10 no noise
+        /* a*b + c*d + e*f + a*g*i + c*f*j */
         y[i] = x[i][0] * x[i][1] +
                x[i][2] * x[i][3] +
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Program.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Program.cs	(revision 11729)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Program.cs	(revision 11730)
@@ -3,8 +3,10 @@
 using System.Data;
 using System.Diagnostics;
+using System.Globalization;
 using System.Linq;
 using System.Text;
 using System.Threading.Tasks;
 using HeuristicLab.Algorithms.Bandits;
+using HeuristicLab.Algorithms.Bandits.Models;
 using HeuristicLab.Algorithms.GrammaticalOptimization;
 using HeuristicLab.Problems.GrammaticalOptimization;
@@ -13,45 +15,89 @@
   class Program {
     static void Main(string[] args) {
-      // RunDemo();
-      RunGridTest();
+      CultureInfo.DefaultThreadCurrentCulture = CultureInfo.InvariantCulture;
+
+      RunDemo();
+      //RunGridTest();
     }
 
     private static void RunGridTest() {
-      int maxIterations = 150000;
-      var globalRandom = new Random(31415);
-      var reps = 10;
-      Parallel.ForEach(new int[] { 1, 5, 10, 100, 500, 1000 }, (randomTries) => {
-        Random localRand;
-        lock (globalRandom) {
-          localRand = new Random(globalRandom.Next());
-        }
-        var policyFactories = new Func<int, IPolicy>[]
+      int maxIterations = 100000; // for poly-10 with 50000 evaluations no successful try with hl yet
+      // var globalRandom = new Random(31415);
+      var localRandSeed = 31415;
+      var reps = 20;
+
+      var policyFactories = new Func<Random, int, IPolicy>[]
         {
-          (numActions) => new RandomPolicy(localRand, numActions), 
-          (numActions) => new UCB1Policy(numActions), 
-          (numActions) => new UCB1TunedPolicy(numActions), 
-          (numActions) => new UCBNormalPolicy(numActions), 
-          (numActions) => new EpsGreedyPolicy(localRand, numActions, 0.01), 
-          (numActions) => new EpsGreedyPolicy(localRand, numActions, 0.05), 
-          (numActions) => new EpsGreedyPolicy(localRand, numActions, 0.1), 
-          (numActions) => new EpsGreedyPolicy(localRand, numActions, 0.2), 
-          (numActions) => new EpsGreedyPolicy(localRand, numActions, 0.5), 
-          (numActions) => new GaussianThompsonSamplingPolicy(localRand, numActions), 
-          (numActions) => new BernoulliThompsonSamplingPolicy(localRand, numActions)
+          (rand, numActions) => new GaussianThompsonSamplingPolicy(rand, numActions), 
+          (rand, numActions) => new BernoulliThompsonSamplingPolicy(rand, numActions),
+          (rand, numActions) => new RandomPolicy(rand, numActions), 
+          (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.01), 
+          (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.05), 
+          (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.1), 
+          (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.2), 
+          (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.5), 
+          (rand, numActions) => new UCTPolicy(numActions, 0.1),
+          (rand, numActions) => new UCTPolicy(numActions, 0.5),
+          (rand, numActions) => new UCTPolicy(numActions, 1),
+          (rand, numActions) => new UCTPolicy(numActions, 2),
+          (rand, numActions) => new UCTPolicy(numActions, 5),
+          (rand, numActions) => new UCTPolicy(numActions, 10),
+          (rand, numActions) => new UCB1Policy(numActions), 
+          (rand, numActions) => new UCB1TunedPolicy(numActions), 
+          (rand, numActions) => new UCBNormalPolicy(numActions), 
+          (rand, numActions) => new BoltzmannExplorationPolicy(rand, numActions, 0.1), 
+          (rand, numActions) => new BoltzmannExplorationPolicy(rand, numActions, 0.5),
+          (rand, numActions) => new BoltzmannExplorationPolicy(rand, numActions, 1),
+          (rand, numActions) => new BoltzmannExplorationPolicy(rand, numActions, 5),
+          (rand, numActions) => new BoltzmannExplorationPolicy(rand, numActions, 10),
+          (rand, numActions) => new BoltzmannExplorationPolicy(rand, numActions, 20),
+          (rand, numActions) => new BoltzmannExplorationPolicy(rand, numActions, 100),
+          (rand, numActions) => new ChernoffIntervalEstimationPolicy(numActions, 0.01), 
+          (rand, numActions) => new ChernoffIntervalEstimationPolicy(numActions, 0.05),
+          (rand, numActions) => new ChernoffIntervalEstimationPolicy(numActions, 0.1),
+          (rand, numActions) => new ChernoffIntervalEstimationPolicy(numActions, 0.2),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 10, 0.01), 
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 10, 0.05),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 10, 0.1),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 10, 0.2),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 100, 0.01), 
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 100, 0.05),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 100, 0.1),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 100, 0.2),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 1000, 0.01), 
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 1000, 0.05),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 1000, 0.1),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 1000, 0.2),
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 5000, 0.01), 
+          (rand, numActions) => new ThresholdAscentPolicy(numActions, 10000, 0.01), 
         };
 
-        foreach (var policyFactory in policyFactories)
-          for (int i = 0; i < reps; i++) {
+      var tasks = new List<Task>();
+      foreach (var randomTries in new int[] { 1, 10, /* 5, 100 /*, 500, 1000 */}) {
+        foreach (var policyFactory in policyFactories) {
+          var myPolicyFactory = policyFactory;
+          var myRandomTries = randomTries;
+          var localRand = new Random(localRandSeed);
+          var options = new ParallelOptions();
+          options.MaxDegreeOfParallelism = 1;
+          Parallel.For(0, reps, options, (i) => {
+            //var t = Task.Run(() => {
+            Random myLocalRand;
+            lock (localRand)
+              myLocalRand = new Random(localRand.Next());
+
+            //for (int i = 0; i < reps; i++) {
+
             int iterations = 0;
             var sw = new Stopwatch();
             var globalStatistics = new SentenceSetStatistics();
 
-            // var problem = new SymbolicRegressionPoly10Problem();
-            var problem = new SantaFeAntProblem();
+            var problem = new SymbolicRegressionPoly10Problem();
+            //var problem = new SantaFeAntProblem();
             //var problem = new PalindromeProblem();
             //var problem = new HardPalindromeProblem();
             //var problem = new RoyalPairProblem();
             //var problem = new EvenParityProblem();
-            var alg = new MctsSampler(problem, 17, localRand, randomTries, policyFactory);
+            var alg = new MctsSampler(problem, 25, myLocalRand, myRandomTries, myPolicyFactory);
             //var alg = new ExhaustiveBreadthFirstSearch(problem, 25);
             //var alg = new AlternativesContextSampler(problem, 25);
@@ -61,5 +107,5 @@
               globalStatistics.AddSentence(sentence, quality);
               if (iterations % 10000 == 0) {
-                Console.WriteLine("{0} {1} {2}", randomTries, policyFactory(1), globalStatistics);
+                Console.WriteLine("{0,4} {1,7} {2,5} {3,25} {4}", alg.treeDepth, alg.treeSize, myRandomTries, myPolicyFactory(myLocalRand, 1), globalStatistics);
               }
             };
@@ -70,11 +116,33 @@
 
             sw.Stop();
-          }
-      });
+            //Console.WriteLine("{0,5} {1} {2}", randomTries, policyFactory(1), globalStatistics);
+            //}
+            //});
+            //tasks.Add(t);
+          });
+        }
+      }
+      //Task.WaitAll(tasks.ToArray());
     }
 
     private static void RunDemo() {
-      // TODO: implement threshold ascent
-      // TODO: implement inspection for MCTS
+      // TODO: warum funktioniert die alte Implementierung von GaussianThompson besser für SantaFe als alte? Siehe Vergleich: alte vs. neue implementierung GaussianThompsonSampling
+      // TODO: why does GaussianThompsonSampling work so well with MCTS for the artificial ant problem?
+      // TODO: wie kann ich sampler noch vergleichen bzw. was kann man messen um die qualität des samplers abzuschätzen (bis auf qualität und iterationen bis zur besten lösung) => ziel schnellere iterationen zu gutem ergebnis
+      // TODO: likelihood für R=1 bei Gaussian oder GaussianMixture einfach berechenbar?
+      // TODO: research thompson sampling for max bandit?
+      // TODO: ausführlicher test von strategien für k-armed max bandit
+      // TODO: verify TA implementation using example from the original paper
+      // TODO: reference HL.ProblemInstances and try on tower dataset
+      // TODO: compare results for different policies also for the symb-reg problem
+      // TODO: separate policy from MCTS tree data structure to allow sharing of information over disconnected parts of the tree (semantic equivalence)
+      // TODO: implement thompson sampling for gaussian mixture models
+      // TODO: implement inspection for MCTS (eventuell interactive command line für statistiken aus dem baum anzeigen)
+      // TODO: implement ACO-style bandit policy
+      // TODO: implement sequences that can be manipulated in-place (instead of strings), alternatives are also stored as sequences, for a sequence the index of the first NT-symb can be stored 
+      // TODO: gleichzeitige modellierung von transformierter zielvariable (y, 1/y, log(y), exp(y), sqrt(y), ...)
+      // TODO: vergleich bei complete-randomly möglichst kurze sätze generieren vs. einfach zufällig alternativen wählen
+      // TODO: reward discounting (für veränderliche reward distributions über zeit). speziellen unit-test dafür erstellen
+
 
       int maxIterations = 10000000;
@@ -84,7 +152,7 @@
       string bestSentence = "";
       var globalStatistics = new SentenceSetStatistics();
-      var random = new Random(31415);
-
-      // var problem = new SymbolicRegressionPoly10Problem();
+      var random = new Random();
+
+      //var problem = new SymbolicRegressionPoly10Problem();
       var problem = new SantaFeAntProblem();
       //var problem = new PalindromeProblem();
@@ -92,7 +160,10 @@
       //var problem = new RoyalPairProblem();
       //var problem = new EvenParityProblem();
-      var alg = new MctsSampler(problem, 17, random);
-      //var alg = new ExhaustiveBreadthFirstSearch(problem, 25);
-      //var alg = new AlternativesContextSampler(problem, 25);
+      //var alg = new MctsSampler(problem, 17, random, 1, (rand, numActions) => new GenericThompsonSamplingPolicy(rand, numActions, new GaussianModel(numActions, 0.5, 10)));
+      //var alg = new ExhaustiveBreadthFirstSearch(problem, 17);
+      //var alg = new AlternativesContextSampler(problem, random, 17, 4, (rand, numActions) => new RandomPolicy(rand, numActions));
+      //var alg = new ExhaustiveDepthFirstSearch(problem, 17);
+      // var alg = new AlternativesSampler(problem, 17);
+      var alg = new RandomSearch(problem, random, 17);
 
       alg.FoundNewBestSolution += (sentence, quality) => {
@@ -104,7 +175,11 @@
         iterations++;
         globalStatistics.AddSentence(sentence, quality);
+        if (iterations % 1000 == 0) {
+          //alg.PrintStats();
+        }
         if (iterations % 10000 == 0) {
           //Console.WriteLine("{0,10} {1,10:F5} {2,10:F5} {3}", iterations, bestQuality, quality, sentence);
-          Console.WriteLine(globalStatistics.ToString());
+          //Console.WriteLine("{0,4} {1,7} {2}", alg.treeDepth, alg.treeSize, globalStatistics);
+          Console.WriteLine(globalStatistics);
         }
       };
